using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using assignment2.Interfaces;
using assignment2.Services;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;

namespace assignment2.Controllers
{
    [Route("[controller]")]
    [ApiController]
    public class LogController : ControllerBase
    {
        private readonly ILogService _logsService;
        public LogController(ILogService logsService) => _logsService = logsService;

        //[Authorize(Roles = "Admin")]
        [HttpGet]
        public async Task<IActionResult> GetAsync(string? user, string? operation, DateTime? startDate, DateTime? endTime, string? level)
        {
            var logs = await _logsService.GetAsync(user, operation, startDate, endTime, level);
            return Ok(logs);
        }

    }
}