﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace assignment1.Migrations
{
    /// <inheritdoc />
    public partial class guests : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_SharedExperiences_Joined_Experiences_Experiences_ExperiencesExperienceId",
                table: "SharedExperiences_Joined_Experiences");

            migrationBuilder.DropForeignKey(
                name: "FK_SharedExperiences_Joined_Experiences_SharedExperience_SharedExperiencesSharedExperienceId",
                table: "SharedExperiences_Joined_Experiences");

            migrationBuilder.DropTable(
                name: "Guest");

            migrationBuilder.DropPrimaryKey(
                name: "PK_SharedExperiences_Joined_Experiences",
                table: "SharedExperiences_Joined_Experiences");

            migrationBuilder.DropPrimaryKey(
                name: "PK_SharedExperience",
                table: "SharedExperience");

            migrationBuilder.RenameTable(
                name: "SharedExperiences_Joined_Experiences",
                newName: "SharedExperiencesExperiences");

            migrationBuilder.RenameTable(
                name: "SharedExperience",
                newName: "SharedExperiences");

            migrationBuilder.RenameIndex(
                name: "IX_SharedExperiences_Joined_Experiences_SharedExperiencesSharedExperienceId",
                table: "SharedExperiencesExperiences",
                newName: "IX_SharedExperiencesExperiences_SharedExperiencesSharedExperienceId");

            migrationBuilder.AddPrimaryKey(
                name: "PK_SharedExperiencesExperiences",
                table: "SharedExperiencesExperiences",
                columns: new[] { "ExperiencesExperienceId", "SharedExperiencesSharedExperienceId" });

            migrationBuilder.AddPrimaryKey(
                name: "PK_SharedExperiences",
                table: "SharedExperiences",
                column: "SharedExperienceId");

            migrationBuilder.CreateTable(
                name: "Guests",
                columns: table => new
                {
                    GuestID = table.Column<int>(type: "int", nullable: false)
                        .Annotation("SqlServer:Identity", "1, 1"),
                    Name = table.Column<string>(type: "nvarchar(max)", nullable: false),
                    Age = table.Column<int>(type: "int", nullable: false),
                    Phone = table.Column<int>(type: "int", nullable: false),
                    GuestID1 = table.Column<int>(type: "int", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Guests", x => x.GuestID);
                    table.ForeignKey(
                        name: "FK_Guests_Guests_GuestID1",
                        column: x => x.GuestID1,
                        principalTable: "Guests",
                        principalColumn: "GuestID");
                });

            migrationBuilder.CreateTable(
                name: "GuestsExperiences",
                columns: table => new
                {
                    ExperiencesExperienceId = table.Column<int>(type: "int", nullable: false),
                    GuestsGuestID = table.Column<int>(type: "int", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_GuestsExperiences", x => new { x.ExperiencesExperienceId, x.GuestsGuestID });
                    table.ForeignKey(
                        name: "FK_GuestsExperiences_Experiences_ExperiencesExperienceId",
                        column: x => x.ExperiencesExperienceId,
                        principalTable: "Experiences",
                        principalColumn: "ExperienceId",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_GuestsExperiences_Guests_GuestsGuestID",
                        column: x => x.GuestsGuestID,
                        principalTable: "Guests",
                        principalColumn: "GuestID",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "GuestsSharedExperiences",
                columns: table => new
                {
                    GuestsGuestID = table.Column<int>(type: "int", nullable: false),
                    SharedExperiencesSharedExperienceId = table.Column<int>(type: "int", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_GuestsSharedExperiences", x => new { x.GuestsGuestID, x.SharedExperiencesSharedExperienceId });
                    table.ForeignKey(
                        name: "FK_GuestsSharedExperiences_Guests_GuestsGuestID",
                        column: x => x.GuestsGuestID,
                        principalTable: "Guests",
                        principalColumn: "GuestID",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_GuestsSharedExperiences_SharedExperiences_SharedExperiencesSharedExperienceId",
                        column: x => x.SharedExperiencesSharedExperienceId,
                        principalTable: "SharedExperiences",
                        principalColumn: "SharedExperienceId",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_Guests_GuestID1",
                table: "Guests",
                column: "GuestID1");

            migrationBuilder.CreateIndex(
                name: "IX_GuestsExperiences_GuestsGuestID",
                table: "GuestsExperiences",
                column: "GuestsGuestID");

            migrationBuilder.CreateIndex(
                name: "IX_GuestsSharedExperiences_SharedExperiencesSharedExperienceId",
                table: "GuestsSharedExperiences",
                column: "SharedExperiencesSharedExperienceId");

            migrationBuilder.AddForeignKey(
                name: "FK_SharedExperiencesExperiences_Experiences_ExperiencesExperienceId",
                table: "SharedExperiencesExperiences",
                column: "ExperiencesExperienceId",
                principalTable: "Experiences",
                principalColumn: "ExperienceId",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_SharedExperiencesExperiences_SharedExperiences_SharedExperiencesSharedExperienceId",
                table: "SharedExperiencesExperiences",
                column: "SharedExperiencesSharedExperienceId",
                principalTable: "SharedExperiences",
                principalColumn: "SharedExperienceId",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_SharedExperiencesExperiences_Experiences_ExperiencesExperienceId",
                table: "SharedExperiencesExperiences");

            migrationBuilder.DropForeignKey(
                name: "FK_SharedExperiencesExperiences_SharedExperiences_SharedExperiencesSharedExperienceId",
                table: "SharedExperiencesExperiences");

            migrationBuilder.DropTable(
                name: "GuestsExperiences");

            migrationBuilder.DropTable(
                name: "GuestsSharedExperiences");

            migrationBuilder.DropTable(
                name: "Guests");

            migrationBuilder.DropPrimaryKey(
                name: "PK_SharedExperiencesExperiences",
                table: "SharedExperiencesExperiences");

            migrationBuilder.DropPrimaryKey(
                name: "PK_SharedExperiences",
                table: "SharedExperiences");

            migrationBuilder.RenameTable(
                name: "SharedExperiencesExperiences",
                newName: "SharedExperiences_Joined_Experiences");

            migrationBuilder.RenameTable(
                name: "SharedExperiences",
                newName: "SharedExperience");

            migrationBuilder.RenameIndex(
                name: "IX_SharedExperiencesExperiences_SharedExperiencesSharedExperienceId",
                table: "SharedExperiences_Joined_Experiences",
                newName: "IX_SharedExperiences_Joined_Experiences_SharedExperiencesSharedExperienceId");

            migrationBuilder.AddPrimaryKey(
                name: "PK_SharedExperiences_Joined_Experiences",
                table: "SharedExperiences_Joined_Experiences",
                columns: new[] { "ExperiencesExperienceId", "SharedExperiencesSharedExperienceId" });

            migrationBuilder.AddPrimaryKey(
                name: "PK_SharedExperience",
                table: "SharedExperience",
                column: "SharedExperienceId");

            migrationBuilder.CreateTable(
                name: "Guest",
                columns: table => new
                {
                    GuestId = table.Column<int>(type: "int", nullable: false)
                        .Annotation("SqlServer:Identity", "1, 1"),
                    ExperienceId = table.Column<int>(type: "int", nullable: true),
                    SharedExperienceId = table.Column<int>(type: "int", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Guest", x => x.GuestId);
                    table.ForeignKey(
                        name: "FK_Guest_Experiences_ExperienceId",
                        column: x => x.ExperienceId,
                        principalTable: "Experiences",
                        principalColumn: "ExperienceId");
                    table.ForeignKey(
                        name: "FK_Guest_SharedExperience_SharedExperienceId",
                        column: x => x.SharedExperienceId,
                        principalTable: "SharedExperience",
                        principalColumn: "SharedExperienceId");
                });

            migrationBuilder.CreateIndex(
                name: "IX_Guest_ExperienceId",
                table: "Guest",
                column: "ExperienceId");

            migrationBuilder.CreateIndex(
                name: "IX_Guest_SharedExperienceId",
                table: "Guest",
                column: "SharedExperienceId");

            migrationBuilder.AddForeignKey(
                name: "FK_SharedExperiences_Joined_Experiences_Experiences_ExperiencesExperienceId",
                table: "SharedExperiences_Joined_Experiences",
                column: "ExperiencesExperienceId",
                principalTable: "Experiences",
                principalColumn: "ExperienceId",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_SharedExperiences_Joined_Experiences_SharedExperience_SharedExperiencesSharedExperienceId",
                table: "SharedExperiences_Joined_Experiences",
                column: "SharedExperiencesSharedExperienceId",
                principalTable: "SharedExperience",
                principalColumn: "SharedExperienceId",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
