﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace assignment1.Migrations
{
    /// <inheritdoc />
    public partial class _01_guestfriends : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Guests_Guests_GuestID1",
                table: "Guests");

            migrationBuilder.DropIndex(
                name: "IX_Guests_GuestID1",
                table: "Guests");

            migrationBuilder.DropColumn(
                name: "GuestID1",
                table: "Guests");

            migrationBuilder.CreateTable(
                name: "GuestFriends",
                columns: table => new
                {
                    GuestId = table.Column<int>(type: "int", nullable: false),
                    FriendId = table.Column<int>(type: "int", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_GuestFriends", x => new { x.GuestId, x.FriendId });
                    table.CheckConstraint("CHK_IDS_ORDER", "(GuestId < FriendId)");
                    table.ForeignKey(
                        name: "FK_GuestFriends_Guests_FriendId",
                        column: x => x.FriendId,
                        principalTable: "Guests",
                        principalColumn: "GuestID",
                        onDelete: ReferentialAction.Restrict);
                    table.ForeignKey(
                        name: "FK_GuestFriends_Guests_GuestId",
                        column: x => x.GuestId,
                        principalTable: "Guests",
                        principalColumn: "GuestID",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateIndex(
                name: "IX_GuestFriends_FriendId",
                table: "GuestFriends",
                column: "FriendId");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "GuestFriends");

            migrationBuilder.AddColumn<int>(
                name: "GuestID1",
                table: "Guests",
                type: "int",
                nullable: true);

            migrationBuilder.CreateIndex(
                name: "IX_Guests_GuestID1",
                table: "Guests",
                column: "GuestID1");

            migrationBuilder.AddForeignKey(
                name: "FK_Guests_Guests_GuestID1",
                table: "Guests",
                column: "GuestID1",
                principalTable: "Guests",
                principalColumn: "GuestID");
        }
    }
}
